const router = require('koa-router')() //导入 koa-router
const redis = require("../model/db/redis_db")  //导入 db.js
const mysql = require("../model/db/account_info_db")  //导入 db.js
const logger = require('../model/logger')
const BigNumber = require('bignumber.js')
var moralis = require('../model/moralis_sdk.js')
router.prefix('/test/account/');

router.post('/getAccountTransactions', async (ctx) => {
    ctx.body = await moralis.getTokenTransfersV2(ctx.request.body)
})

router.post('/getAccountBalances', async (ctx) => {
    ctx.body = await mysql.getAccountBalances(ctx.request.body)
})


router.post('/getAccountAllCoins', async (ctx) => {
    ctx.body = await moralis.getAccountAllCoins(ctx.request.body)
})

module.exports = router

