const router = require('koa-router')() //导入 koa-router
const redis = require("../model/db/redis_db")  //导入 db.js
const mysql = require("../model/db/mysql_db")  //导入 db.js
// https://github.com/luin/ioredis#readme
const logger = require('../model/logger')

var remote_config_db = require("../model/db/remote_config_db");
var collect_coins_db = require("../model/db/collect_coins_db");
var withdraw_db = require("../model/db/withdraw_db");
const BigNumber = require('bignumber.js')
router.prefix('/test');
router.post('/set', async (ctx) => {
    // const obj = ctx.request.body;
    // console.log("set:",obj)
    // redis.redis_set(obj.key, obj.value);
    // ctx.body = obj.key + " - "+ obj.value
    // var arrays = [1, 2, 3, 4, 5]

    for (let index = 0; index < 10; index++) {
        redis.redis_push('WITHDRAW_QUEUE_KEY', JSON.stringify({ code: index }))
    }

    while (true) {
        var item = await redis.redis_pop('WITHDRAW_QUEUE_KEY')
        logger.log('item', typeof item, JSON.parse(item));
        if (!item) {
            break
        }
    }
    logger.log('exit');
})

router.post('/get', async (ctx) => {
    const obj = ctx.request.body;
    console.log("get:", obj)
    await redis.redis_get(obj.key).then((result) => {
        // ctx.body = "key:" + obj.key + " \n" + "value:" + result
        console.error('>>>>>>>>>>>>redis_get' + "key:" + obj.key + "-" + "value:" + result)
    });
    await redis.readRedis(obj.key).then((result) => {
        ctx.body = "readRedis key:" + obj.key + " \n" + "value:" + result
    });
})


router.post('/queryUserPrivateKey', async (ctx) => {
    const obj = ctx.request.body;
    console.log("queryUserPrivateKey:", obj)
    // await mysql.queryUserPrivateKeyFromUserAddress(obj.userAddress).then(function (mysqlDbResp){
    //     ctx.body = "results:" +  JSON.stringify(mysqlDbResp)
    //     console.log('mysqlDbResp=', JSON.stringify(mysqlDbResp));
    // })

    await mysql.queryCompanyInfoFromId(0).then(e => {
        ctx.body = "results:" + JSON.stringify(e)
    })
})



async function query() {
    // console.log('collect_coins', await remote_config_db.isPause('collect_coins'))
    // console.log('withdraw', await remote_config_db.isPause('withdraw'))

    // console.log('isBlackList', await remote_config_db.isBlackList('collect_coins', 'bsc', '0x003D33E1eD599a92aaacF9a710E10fC62143B9e0'))
    console.log('getTokenCollectCoinsBlacklist',await remote_config_db.tokenCollectCoinsBlacklistExist('token_collect', 'bsc', '0x8860313deeb10a2863bc05b04b37897044edbda1'))
}


async function getInfo() {
    var collect_ret = await collect_coins_db.query_collect_total_fee();
    var withdraw_ret = await withdraw_db.getWidthdrawTotalFee()
    // console.error('query_collect_total_fee:', let.results)
    var total_gas_fee = 0
    var total_in_coins = []
    for (let index = 0; index < collect_ret.results.length; index++) {
        const element = collect_ret.results[index];
        total_gas_fee += parseInt(element.total_gas_fee)
    }

    var total_gas_fee2 = 0
    for (let index = 0; index < withdraw_ret.length; index++) {
        const element = withdraw_ret[index];
        if (element.gas_price && element.gas_limit)
            total_gas_fee2 += (parseInt(element.gas_price) * parseInt(element.gas_limit))
    }

    console.log('total_gas_pee', total_gas_fee)
    console.log('total_gas_fee2', total_gas_fee2)
    console.log('total', total_gas_fee2 + total_gas_fee)
}

async function getInfo2() {
    var collect_ret = await collect_coins_db.query_collect_total_fee();
    var withdraw_ret = await withdraw_db.getWidthdrawTotalFee()
    // console.error('query_collect_total_fee:', let.results)
    // var total_gas_fee = 0
    const total_in_coins = new Map();
    // for (let index = 0; index < collect_ret.results.length; index++) {
    //     const element = collect_ret.results[index];
    //     if(element.chain && element.chain == 'czz')continue
    //     total_gas_fee += parseInt(element.total_gas_fee)
    //     if (element.transfers) {
    //         var opts = JSON.parse(element.transfers)
    //         for (let index = 0; index < opts.length; index++) {
    //             const element = opts[index];
    //             if (total_in_coins.get(element.contractAddress) != null) {
    //                 var ins = total_in_coins.get(element.contractAddress)
    //                 ins += BigInt(element.amount)
    //                 total_in_coins.set(element.contractAddress, ins)
    //             } else {
    //                 total_in_coins.set(element.contractAddress, BigInt(element.amount))
    //             }
    //             console.log('total_in_coins', element);
    //         }
    //         // break
    //     }
    // }
    // console.log('total_in_coins', total_in_coins);
    // console.log('total_in_coins2', BigInt(100000000000000000000)+BigInt(100000000000000000000));

    var total_gas_fee2 = 0
    for (let index = 0; index < withdraw_ret.length; index++) {
        const element = withdraw_ret[index];
        // if (element.gas_price && element.gas_limit)
        // total_gas_fee2 += (parseInt(element.gas_price) * parseInt(element.gas_limit))
        // console.log('total_in_coins', element);
        if (total_in_coins.get(element.contract_address) != null) {
            var ins = total_in_coins.get(element.contract_address)
            ins += BigInt(element.amount)
            total_in_coins.set(element.contract_address, ins)
        } else {
            console.log('total_in_coins price', total_in_coins);
            total_in_coins.set(element.contract_address, BigInt(element.amount))
        }
    }
    console.log('total_in_coins', total_in_coins);



    //     console.log('total_gas_pee', total_gas_fee)
    //     console.log('total_gas_fee2', total_gas_fee2)
    //     console.log('total', total_gas_fee2 + total_gas_fee)
}

function getInfo3() {
    // console.log('1018087452840284941787', 1018087452840284941787 / (10**18))

    // console.log('101000000000000000000', 101000000000000000000 / (10**18) * 0.6476)

    // console.log('64585000000000000000000', 64585000000000000000000 / (10**18) * 0.0005)

    
    // console.log('1000000000000000', 1000000000000000 / (10**18) * 0.0482)
    // console.log('2410418338592426908426', 2410418338592426908426 / (10**18) * 0.2074)
    // console.log('2501561242336020120158', 2501561242336020120158 / (10**18) * 0.2074)

}
getInfo3()
// getInfo2()
// query()
module.exports = router

