生成 koa2 项目：
npm install koa2-generator -g
koa2 project

安装必要的库
```shell
npm install
```
配置环境变量

```
vim ~/.bashrc
export DENET_CRYPT_KEY=
export DENET_CRYPT_IV=
source ~/.bashrc
```

启动
```
<!-- 开发环境启动 -->
NODE_ENV=dev ./node_modules/.bin/nodemon bin/www
<!-- 测试环境启动-->
NODE_ENV=test pm2 start bin/www
<!-- 线上环境启动 -->
NODE_ENV=prd pm2 start bin/www
```

健康检查
```
http://localhost:3000/healthcheck
```
进入 server 看 log
```shell

sudo ssh -i ~/.ssh/de-net.pem ubuntu@34.207.131.244

sudo   su root

ssh -i /home/ubuntu/denet-security.pem   ubuntu@10.0.1.25

# ssh    10.0.1.168

# docker ps

# docker ps  -a

# docker exec  -it   容器id   bash

pm2 logs

```

监控：
https://open.feishu.cn/open-apis/bot/v2/hook/18dfe21f-b1bd-46ca-a8c7-c85e1c84f02d


redis connect:
- redis-cli -c -h  denet-chain-prod.y2slbl.clustercfg.memorydb.us-east-1.amazonaws.com
- lrange COLLECT_CONIS_QUEUE_KEY 0 -1 

## 文档
- [moralis 中文版](https://www.w3cschool.cn/moralis/moralis-39s73nzu.html)
- [moralis 英文版](https://docs.moralis.io/moralis-dapp/web3-api/rate-limit)
- [token 技术文档](https://st94nif1cq.feishu.cn/docs/doccnNxG2UwHPCdZXbywgbdy13f)
- [项目排期](https://st94nif1cq.feishu.cn/docs/doccntqBN5JHQriK7xz1SId3EC0)
- [node 业务服务流程图](https://st94nif1cq.feishu.cn/docs/doccn45PiFsrLnlDLjs5KXNa57d#)
- [moralis sdk](https://docs.moralis.io/moralis-dapp/web3-sdk/native#gettransaction-new)
- [moralis server](https://admin.moralis.io/servers)
- [node 服务文档 ](https://st94nif1cq.feishu.cn/docs/doccnNxG2UwHPCdZXbywgbdy13f#)
- [测试币准备](https://st94nif1cq.feishu.cn/docs/doccn2G0r0HOH0L1Z05uaJDFA2g#)
- [监控预警](https://github.com/zhangky01/feishu-robot)
